package org.jetbrains.kotlinx.statistics.binning

data class BinModel<R: Comparable<R>, T>(val bins: List<BinWithValue<R, T>>): Iterable<BinWithValue<R,T>> by bins {
    /*operator fun get(key: C) = bins.find { key in it.range }
    operator fun contains(key: C) = bins.any { key in it.range }*/
    fun <V> aggregate(function: (T) -> V): BinModel<R, V> {
        return BinModel(bins.map {
            BinWithValue(it.bin, function(it.value))
        })
    }
}

fun<R: Comparable<R>, T> BinModel<R, List<T>>.count() = aggregate { it.count() }
