package org.jetbrains.kotlinx.statistics.binning

data class Bin<R>(
    val range: Pair<R, R>,
    val startInclusive: Boolean = true,
    val endInclusive: Boolean = false
) {
    //operator fun contains(key: R) = key >= range.first && key <= range.second

    private val openBracket: Char
        get() = if (startInclusive) {
        '['
    } else {
        '('
        }

    private val closeBracket: Char
        get() = if (endInclusive) {
            ']'
        } else {
            ')'
        }
    override fun toString(): String {
        return "$openBracket${range.first}, ${range.second}$closeBracket"
    }
}

fun Bin<Double>.center(): Double {
    return (range.first + range.second) / 2.0
}

data class BinWithValue<R, T>(val bin: Bin<R>, val value: T) {
   // operator fun contains(key: R) = key >= range.first && key <= range.second

    /*override fun toString(): String {
        return "Bin(range=$bin, value=$value)"
    }*/
}