package org.jetbrains.kotlinx.statistics.binning

public sealed interface BinsOption {
    public companion object {
        public fun byNumber(number: Int): BinsOption = ByNumber(number)
        public fun byWidth(width: Double): BinsOption = ByWidth(width)
    }
}

internal data class ByNumber(val number: Int) : BinsOption
internal data class ByWidth(val width: Double) : BinsOption

public sealed interface BinsAlign {
    public companion object {
        public fun none(): BinsAlign = None
        public fun center(posValue: Double): BinsAlign = Center(posValue)
        public fun boundary(posValue: Double): BinsAlign = Boundary(posValue)
    }
}

internal data class Center(val posValue: Double) : BinsAlign
internal data class Boundary(val posValue: Double) : BinsAlign
internal object None: BinsAlign
