package org.jetbrains.kotlinx.statistics.distribution

class TDistribution(val degreesOfFreedom: Double) {
    private val math3Distribution = org.jetbrains.kotlinx.statistics.math3.distribution.TDistribution(
        degreesOfFreedom
    )
    fun sample(size: Int): DoubleArray {
        return math3Distribution.sample(size)
    }
    fun pdf(x: Double): Double {
        return math3Distribution.density(x)
    }

    companion object {
        fun pdf(degreesOfFreedom: Double, x:Double): Double {
            return org.jetbrains.kotlinx.statistics.math3.distribution.TDistribution.density(
                x, degreesOfFreedom
            )
        }
    }
}