package org.jetbrains.kotlinx.statistics.stats

data class StatisticsSummary(
    val count: Int,
    val min: Double,
    val max: Double,
    val sum: Double,
    val mean: Double,
    val variance: Double,
    val standardDeviation: Double,
    val median: Double,
    val skewness: Double,
    val kurtosis: Double
) {
    override fun toString(): String {
        return """
             Count: $count
             Min: $min
             Max: $max
             Sum: $sum
             Mean: $mean
             Variance: $variance
             Standard deviation: $standardDeviation
             Median: $median
             Skewness: $skewness
             Kurtosis: $kurtosis
        """.trimIndent()
    }
}
