package org.jetbrains.kotlinx.statistics.stats

import org.jetbrains.kotlinx.statistics.math3.stat.descriptive.DescriptiveStatistics

fun Iterable<Number>.summary(): StatisticsSummary {
    return with(DescriptiveStatistics(map {it.toDouble()}.toDoubleArray())) {
        StatisticsSummary(
            n.toInt(),
            min,
            max,
            sum,
            mean,
            variance,
            standardDeviation,
            getPercentile(50.0),
            skewness,
            kurtosis
        )
    }
}
