package org.jetbrains.kotlinx.statistics.test.t

import org.jetbrains.kotlinx.statistics.math3.stat.inference.TTest
import kotlin.jvm.JvmName

fun tTest(sample: Iterable<Number>, mu: Double): TTestResult {
    val data = sample.map { it.toDouble() }.toDoubleArray()
    return TTestResult(TTest().t(mu, data),
        TTest().tTest(mu, data))
}

@JvmName("t_test_ext")
fun Iterable<Number>.tTest(mu: Double): TTestResult {
    val data = map { it.toDouble() }.toDoubleArray()
    return TTestResult(TTest().t(mu, data),
        TTest().tTest(mu, data))
}
