package org.jetbrains.kotlinx.statistics.test.t

import org.jetbrains.kotlinx.statistics.math3.stat.inference.TTest

fun tTestInd(sample1: Iterable<Number>, sample2: Iterable<Number>, equalVar: Boolean = true): TTestResult {
    val data1 = sample1.map { it.toDouble() }.toDoubleArray()
    val data2 = sample2.map { it.toDouble() }.toDoubleArray()
    return if (equalVar) {
        TTestResult(
            TTest().homoscedasticT(data1, data2),
            TTest().homoscedasticTTest(data1, data2)
        )
    } else {
        TTestResult(
            TTest().t(data1, data2),
            TTest().tTest(data1, data2)
        )
    }
}
