package org.jetbrains.kotlinx.statistics.dataframe.stat

import org.jetbrains.kotlinx.dataframe.ColumnSelector
import org.jetbrains.kotlinx.dataframe.DataColumn
import org.jetbrains.kotlinx.dataframe.DataFrame
import org.jetbrains.kotlinx.dataframe.columns.ColumnAccessor
import org.jetbrains.kotlinx.statistics.stats.mean
import kotlin.reflect.KProperty

@JvmName("mean_ext")
fun DataColumn<Number>.mean(): Double {
    return values().mean()
}

fun mean(sample: DataColumn<Number>): Double {
    return sample.mean()
}

fun <T, C : Number> DataFrame<T>.mean(
    column: ColumnSelector<T, C>,
): Double {
    return get(column).mean()
}

@Suppress("UNCHECKED_CAST")
fun <T> DataFrame<T>.mean(column: String): Double {
    return (get(column) as DataColumn<Number>).mean()
}

fun <T, C : Number> DataFrame<T>.mean(
    column: ColumnAccessor<C>,
): Double {
    return get(column).mean()
}

fun <T, C : Number> DataFrame<T>.mean(column: KProperty<C>): Double  {
    return get(column).mean()
}
