package org.jetbrains.kotlinx.statistics.dataframe.stat

import org.jetbrains.kotlinx.dataframe.ColumnSelector
import org.jetbrains.kotlinx.dataframe.DataColumn
import org.jetbrains.kotlinx.dataframe.DataFrame
import org.jetbrains.kotlinx.dataframe.columns.ColumnAccessor
import org.jetbrains.kotlinx.statistics.stats.variance
import kotlin.reflect.KProperty

@JvmName("variance_ext")
fun DataColumn<Number>.variance(): Double {
    return values().variance()
}

fun variance(sample: DataColumn<Number>): Double {
    return sample.variance()
}

fun <T, C : Number> DataFrame<T>.variance(
    column: ColumnSelector<T, C>,
): Double {
    return get(column).variance()
}

@Suppress("UNCHECKED_CAST")
fun <T> DataFrame<T>.variance(column: String): Double {
    return (get(column) as DataColumn<Number>).variance()
}

fun <T, C : Number> DataFrame<T>.variance(
    column: ColumnAccessor<C>,
): Double {
    return get(column).variance()
}

fun <T, C : Number> DataFrame<T>.variance(column: KProperty<C>): Double  {
    return get(column).variance()
}
