package org.jetbrains.kotlinx.statistics.dataframe.test.t

import org.jetbrains.kotlinx.dataframe.ColumnsSelector
import org.jetbrains.kotlinx.dataframe.DataColumn
import org.jetbrains.kotlinx.dataframe.DataFrame
import org.jetbrains.kotlinx.dataframe.values
import org.jetbrains.kotlinx.statistics.test.t.*

fun tTestInd(sample1: DataColumn<Number>, sample2: DataColumn<Number>, equalVar: Boolean = true): TTestResult {
    return tTestInd(sample1.values, sample2.values, equalVar)
}

@Suppress("UNCHECKED_CAST")
fun <T> DataFrame<T>.tTestInd(sample1: String, sample2: String, equalVar: Boolean = true): TTestResult {
    return tTestInd(get(sample1) as DataColumn<Number>, get(sample2) as DataColumn<Number>, equalVar)
}

fun <T> DataFrame<T>.tTestInd(equalVar: Boolean = true, selector: ColumnsSelector<T, Number>,): TTestResult {
    val (sample1, sample2) = get(selector)
    return tTestInd(sample1, sample2, equalVar)
}
