package org.jetbrains.kotlinx.statistics.jupyter

import org.jetbrains.kotlinx.jupyter.api.annotations.JupyterLibrary
import org.jetbrains.kotlinx.jupyter.api.libraries.JupyterIntegration
import org.jetbrains.kotlinx.statistics.kandy.statplots.models.StatPlot

@JupyterLibrary
internal class Integration: JupyterIntegration() {
    override fun Builder.onLoaded() {
        import("org.jetbrains.kotlinx.statistics.binning.BinsOption")
        import("org.jetbrains.kotlinx.statistics.binning.BinsAlign")
        import("org.jetbrains.kotlinx.statistics.kandy.layers.*")
        import("org.jetbrains.kotlinx.statistics.kandy.statplots.*")
        import("org.jetbrains.kotlinx.statistics.kandy.stattransform.*")
        import("org.jetbrains.kotlinx.statistics.plotting.bin.*")
        import("org.jetbrains.kotlinx.statistics.plotting.boxplot.*")
        import("org.jetbrains.kotlinx.statistics.plotting.boxplotOutliers.*")
        import("org.jetbrains.kotlinx.statistics.plotting.candlestick.*")
        import("org.jetbrains.kotlinx.statistics.plotting.count.*")
        import("org.jetbrains.kotlinx.statistics.plotting.count2d.*")
        import("org.jetbrains.kotlinx.statistics.plotting.density.*")
        import("org.jetbrains.kotlinx.statistics.plotting.smooth.*")

        render<StatPlot> {it.toPlot()}
    }
}
