package org.jetbrains.kotlinx.statistics.kandy.layers.context

import org.jetbrains.kotlinx.kandy.dsl.internal.LayerCreatorScope
import org.jetbrains.kotlinx.kandy.letsplot.layers.builders.BoxesBuilder
import org.jetbrains.kotlinx.kandy.util.color.Color
import org.jetbrains.kotlinx.statistics.kandy.util.CandlestickBorderLine
import org.jetbrains.kotlinx.statistics.kandy.util.CandlestickConfiguration
import org.jetbrains.kotlinx.statistics.kandy.util.addDataset
import org.jetbrains.kotlinx.statistics.plotting.candlestick.models.StatCandlestickFrame
import org.jetbrains.kotlinx.statistics.plotting.candlestick.models.WithStatCandlestick

@Suppress("INVISIBLE_MEMBER")
class CandlestickBuilder<T>(parent: LayerCreatorScope, statCandlestickFrame: StatCandlestickFrame<T>) :
    BoxesBuilder(parent, parent.addDataset(statCandlestickFrame)), WithStatCandlestick<T> by statCandlestickFrame {
    val increase: CandlestickConfiguration = CandlestickConfiguration(Color.GREEN, CandlestickBorderLine(Color.GREEN))
    val decrease: CandlestickConfiguration = CandlestickConfiguration(Color.RED, CandlestickBorderLine(Color.RED))
}
