package org.jetbrains.kotlinx.statistics.kandy.layers.context

import org.jetbrains.kotlinx.kandy.dsl.internal.LayerCreatorScope
import org.jetbrains.kotlinx.kandy.letsplot.layers.builders.BarsBuilder
import org.jetbrains.kotlinx.statistics.kandy.util.addDataset
import org.jetbrains.kotlinx.statistics.plotting.bin.models.StatBinGroupBy
import org.jetbrains.kotlinx.statistics.plotting.bin.models.WithStatBinGrouped

@Suppress("INVISIBLE_MEMBER")
class HistogramGroupedBuilder<T> @PublishedApi internal constructor(
    parent: LayerCreatorScope,
    groupBy: StatBinGroupBy<T>
) : BarsBuilder(parent, parent.addDataset(groupBy)),
    WithStatBinGrouped<T> by groupBy
