package org.jetbrains.kotlinx.statistics.kandy.statplots

import org.jetbrains.kotlinx.dataframe.api.getColumnGroup
import org.jetbrains.kotlinx.dataframe.columns.ColumnGroup
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.DataFramePlotBuilder
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*
import org.jetbrains.kotlinx.statistics.plotting.bin.models.BinStatistics
import org.jetbrains.kotlinx.statistics.plotting.bin.models.StatBin
import org.jetbrains.kotlinx.statistics.plotting.bin.models.WithStatBin
import org.jetbrains.kotlinx.kandy.dsl.internal.*

@Suppress("INVISIBLE_MEMBER")
val DataFramePlotBuilder<StatBin>.Stat: WithStatBin.StatHolder
    get() = WithStatBin.StatHolder(dataFrame.getColumnGroup("Stat") as ColumnGroup<BinStatistics>)


@Suppress("INVISIBLE_MEMBER")
val GroupedDataScope<*, StatBin>.Stat: WithStatBin.StatHolder
    get() = WithStatBin.StatHolder(
        datasetBuilder.baseDataFrame.getColumnGroup("Stat") as ColumnGroup<BinStatistics>
    )
