package org.jetbrains.kotlinx.statistics.kandy.statplots

import org.jetbrains.kotlinx.dataframe.api.getColumnGroup
import org.jetbrains.kotlinx.dataframe.columns.ColumnGroup
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*
import org.jetbrains.kotlinx.statistics.plotting.count.models.CountStatistics
import org.jetbrains.kotlinx.statistics.plotting.count.models.StatCount
import org.jetbrains.kotlinx.statistics.plotting.count.models.WithStatCount
import org.jetbrains.kotlinx.kandy.dsl.internal.*
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.GroupedDataScope

@Suppress("INVISIBLE_MEMBER", "UNCHECKED_CAST")
val<X> DataFramePlotBuilder<StatCount<X>>.Stat: WithStatCount.StatHolder<X>
    get() = WithStatCount.StatHolder(dataFrame.getColumnGroup("Stat") as ColumnGroup<CountStatistics<X>>)


@Suppress("INVISIBLE_MEMBER", "UNCHECKED_CAST")
val<X> GroupedDataScope<*, StatCount<X>>.Stat: WithStatCount.StatHolder<X>
    get() = WithStatCount.StatHolder(
        datasetBuilder.baseDataFrame.getColumnGroup("Stat") as ColumnGroup<CountStatistics<X>>
    )
