package org.jetbrains.kotlinx.statistics.kandy.statplots

import org.jetbrains.kotlinx.dataframe.api.getColumnGroup
import org.jetbrains.kotlinx.dataframe.columns.ColumnGroup
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.DataFramePlotBuilder
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.GroupedDataScope
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*
import org.jetbrains.kotlinx.statistics.plotting.count2d.models.Count2DStatistics
import org.jetbrains.kotlinx.statistics.plotting.count2d.models.StatCount2D
import org.jetbrains.kotlinx.statistics.plotting.count2d.models.WithStatCount2D

@Suppress("INVISIBLE_MEMBER", "UNCHECKED_CAST")
val<X, Y> DataFramePlotBuilder<StatCount2D<X, Y>>.Stat: WithStatCount2D.StatHolder<X, Y>
    get() = WithStatCount2D.StatHolder(dataFrame.getColumnGroup("Stat") as ColumnGroup<Count2DStatistics<X, Y>>)


@Suppress("INVISIBLE_MEMBER", "UNCHECKED_CAST")
val<X, Y> GroupedDataScope<*, StatCount2D<X, Y>>.Stat: WithStatCount2D.StatHolder<X, Y>
    get() = WithStatCount2D.StatHolder(
        datasetBuilder.baseDataFrame.getColumnGroup("Stat") as ColumnGroup<Count2DStatistics<X, Y>>
    )
