package org.jetbrains.kotlinx.statistics.kandy.statplots

import org.jetbrains.kotlinx.dataframe.api.getColumnGroup
import org.jetbrains.kotlinx.dataframe.columns.ColumnGroup
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.DataFramePlotBuilder
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.GroupedDataScope
import org.jetbrains.kotlinx.kandy.dsl.internal.*
import org.jetbrains.kotlinx.statistics.plotting.smooth.models.SmoothStatistics
import org.jetbrains.kotlinx.statistics.plotting.smooth.models.StatSmooth
import org.jetbrains.kotlinx.statistics.plotting.smooth.models.WithStatSmooth
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*

@Suppress("INVISIBLE_MEMBER")
val DataFramePlotBuilder<StatSmooth>.Stat: WithStatSmooth.StatHolder
    get() = WithStatSmooth.StatHolder(dataFrame.getColumnGroup("Stat") as ColumnGroup<SmoothStatistics>)


@Suppress("INVISIBLE_MEMBER")
val GroupedDataScope<*, StatSmooth>.Stat: WithStatSmooth.StatHolder
    get() = WithStatSmooth.StatHolder(
        datasetBuilder.baseDataFrame.getColumnGroup("Stat") as ColumnGroup<SmoothStatistics>
    )
