package org.jetbrains.kotlinx.statistics.kandy.statplots.context

import org.jetbrains.kotlinx.kandy.dsl.internal.DatasetBuilder
import org.jetbrains.kotlinx.kandy.dsl.internal.SingleLayerPlotBuilder
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*
import org.jetbrains.kotlinx.kandy.ir.aes.Aes
import org.jetbrains.kotlinx.kandy.ir.geom.Geom
import org.jetbrains.kotlinx.kandy.letsplot.layers.builders.interfaces.BoxesBuilderInterface
import org.jetbrains.kotlinx.kandy.letsplot.layers.builders.subcontext.BorderLine
import org.jetbrains.kotlinx.kandy.letsplot.layers.geom.*
import org.jetbrains.kotlinx.kandy.util.color.Color
import org.jetbrains.kotlinx.statistics.kandy.statplots.models.CandlestickPlot
import org.jetbrains.kotlinx.statistics.kandy.util.CandlestickBorderLine
import org.jetbrains.kotlinx.statistics.kandy.util.CandlestickConfiguration
import org.jetbrains.kotlinx.statistics.plotting.candlestick.models.WithStatCandlestick

@Suppress("INVISIBLE_MEMBER", "CANNOT_OVERRIDE_INVISIBLE_MEMBER", "INVISIBLE_REFERENCE")
public class CandlestickPlotContext<X>(
    private val candlestickPlot: CandlestickPlot<X>
) : SingleLayerPlotBuilder(), BoxesBuilderInterface,
    WithStatCandlestick<X> by candlestickPlot.statCandlestickFrame {
    override val borderLine: BorderLine = BorderLine(bindingHandler)
    override val geom: Geom
        get() = BOXPLOT
    // todo
    override val requiredAes: Set<Aes>
        get() = setOf()

    override val datasetBuilder: DatasetBuilder = DatasetBuilderImpl(candlestickPlot.statCandlestickFrame)

    val increase: CandlestickConfiguration = CandlestickConfiguration(Color.GREEN, CandlestickBorderLine(Color.GREEN))
    val decrease: CandlestickConfiguration = CandlestickConfiguration(Color.RED, CandlestickBorderLine(Color.RED))
}
