package org.jetbrains.kotlinx.statistics.kandy.statplots.context

import org.jetbrains.kotlinx.kandy.dsl.internal.DatasetBuilder
import org.jetbrains.kotlinx.kandy.dsl.internal.SingleLayerPlotBuilder
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*
import org.jetbrains.kotlinx.kandy.ir.aes.Aes
import org.jetbrains.kotlinx.kandy.ir.geom.Geom
import org.jetbrains.kotlinx.kandy.letsplot.internal.*
import org.jetbrains.kotlinx.kandy.letsplot.layers.builders.interfaces.BarsBuilderInterface
import org.jetbrains.kotlinx.kandy.letsplot.layers.builders.subcontext.BorderLine
import org.jetbrains.kotlinx.kandy.letsplot.layers.geom.*
import org.jetbrains.kotlinx.statistics.kandy.statplots.models.CountGroupedPlot
import org.jetbrains.kotlinx.statistics.plotting.count.models.WithStatCountGrouped

@Suppress("INVISIBLE_MEMBER", "INVISIBLE_REFERENCE", "CANNOT_OVERRIDE_INVISIBLE_MEMBER")
public class CountGroupedPlotContext<T, X>(
    private val countPlot: CountGroupedPlot<T, X>
) : SingleLayerPlotBuilder(), BarsBuilderInterface,
    WithStatCountGrouped<T, X> by countPlot.statCountGroupBy {
    override val datasetBuilder: DatasetBuilder = DatasetBuilderImpl(countPlot.statCountGroupBy)
    override val borderLine: BorderLine = BorderLine(bindingHandler)
    override val geom: Geom
        get() = BAR
    override val requiredAes: Set<Aes>
        get() = setOf(X, Y)
}
