package org.jetbrains.kotlinx.statistics.kandy.statplots.context

import org.jetbrains.kotlinx.kandy.dsl.internal.DatasetBuilder
import org.jetbrains.kotlinx.kandy.dsl.internal.SingleLayerPlotBuilder
import org.jetbrains.kotlinx.kandy.ir.aes.Aes
import org.jetbrains.kotlinx.kandy.ir.geom.Geom
import org.jetbrains.kotlinx.kandy.letsplot.internal.*
import org.jetbrains.kotlinx.kandy.letsplot.layers.builders.interfaces.AreaBuilderInterface
import org.jetbrains.kotlinx.kandy.letsplot.layers.builders.subcontext.BorderLine
import org.jetbrains.kotlinx.kandy.letsplot.layers.geom.*
import org.jetbrains.kotlinx.statistics.kandy.statplots.models.DensityGroupedPlot
import org.jetbrains.kotlinx.statistics.plotting.density.models.WithStatDensityGrouped
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*

@Suppress("INVISIBLE_MEMBER", "CANNOT_OVERRIDE_INVISIBLE_MEMBER", "INVISIBLE_REFERENCE")
public class DensityGroupedPlotContext<T>(
    private val densityGroupedPlot: DensityGroupedPlot<T>
) : SingleLayerPlotBuilder(), AreaBuilderInterface,
    WithStatDensityGrouped<T> by densityGroupedPlot.statDensityGroupBy {
    override val datasetBuilder: DatasetBuilder = DatasetBuilderImpl(densityGroupedPlot.statDensityGroupBy)
    override val borderLine: BorderLine = BorderLine(bindingHandler)
    override val geom: Geom
        get() = AREA
    override val requiredAes: Set<Aes>
        get() = setOf(X, Y)
}
