package org.jetbrains.kotlinx.statistics.kandy.statplots.context

import org.jetbrains.kotlinx.kandy.dsl.internal.DatasetBuilder
import org.jetbrains.kotlinx.kandy.dsl.internal.SingleLayerPlotBuilder
import org.jetbrains.kotlinx.kandy.ir.aes.Aes
import org.jetbrains.kotlinx.kandy.ir.geom.Geom
import org.jetbrains.kotlinx.kandy.letsplot.internal.*
import org.jetbrains.kotlinx.kandy.letsplot.layers.builders.interfaces.TilesBuilderInterface
import org.jetbrains.kotlinx.kandy.letsplot.layers.builders.subcontext.BorderLine
import org.jetbrains.kotlinx.kandy.letsplot.layers.geom.*
import org.jetbrains.kotlinx.statistics.kandy.statplots.models.HeatmapPlot
import org.jetbrains.kotlinx.statistics.plotting.count2d.models.WithStatCount2D
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*

@Suppress("INVISIBLE_MEMBER", "CANNOT_OVERRIDE_INVISIBLE_MEMBER", "INVISIBLE_REFERENCE")
public class HeatmapPlotContext<X, Y>(
    private val countPlot: HeatmapPlot<X, Y>
) : SingleLayerPlotBuilder(), TilesBuilderInterface,
    WithStatCount2D<X, Y> by countPlot.statCount2DFrame {
    override val datasetBuilder: DatasetBuilder = DatasetBuilderImpl(countPlot.statCount2DFrame)
    override val borderLine: BorderLine = BorderLine(bindingHandler)
    override val geom: Geom
        get() = TILE
    override val requiredAes: Set<Aes>
        get() = setOf(X, Y)
}
