package org.jetbrains.kotlinx.statistics.kandy.statplots.context

import org.jetbrains.kotlinx.kandy.dsl.internal.DatasetBuilder
import org.jetbrains.kotlinx.kandy.dsl.internal.SingleLayerPlotBuilder
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*
import org.jetbrains.kotlinx.kandy.ir.aes.Aes
import org.jetbrains.kotlinx.kandy.ir.geom.Geom
import org.jetbrains.kotlinx.kandy.letsplot.internal.*
import org.jetbrains.kotlinx.kandy.letsplot.layers.builders.interfaces.BarsBuilderInterface
import org.jetbrains.kotlinx.kandy.letsplot.layers.builders.subcontext.BorderLine
import org.jetbrains.kotlinx.kandy.letsplot.layers.geom.*
import org.jetbrains.kotlinx.statistics.kandy.statplots.models.HistogramGroupedPlot
import org.jetbrains.kotlinx.statistics.plotting.bin.models.WithStatBinGrouped

@Suppress("INVISIBLE_MEMBER", "CANNOT_OVERRIDE_INVISIBLE_MEMBER", "INVISIBLE_REFERENCE")
public class HistogramGroupedPlotContext<T>(
    private val histogramGroupedPlot: HistogramGroupedPlot<T>
) : SingleLayerPlotBuilder(), BarsBuilderInterface,
    WithStatBinGrouped<T> by histogramGroupedPlot.statBinGroupBy {
    override val datasetBuilder: DatasetBuilder = DatasetBuilderImpl(histogramGroupedPlot.statBinGroupBy)
    override val borderLine: BorderLine = BorderLine(bindingHandler)
    override val geom: Geom
        get() = BAR
    override val requiredAes: Set<Aes>
        get() = setOf(X, Y)
}
