package org.jetbrains.kotlinx.statistics.kandy.statplots.context

import org.jetbrains.kotlinx.kandy.dsl.internal.*
import org.jetbrains.kotlinx.kandy.letsplot.layers.geom.*
import org.jetbrains.kotlinx.kandy.letsplot.internal.*
import org.jetbrains.kotlinx.kandy.ir.aes.Aes
import org.jetbrains.kotlinx.kandy.ir.geom.Geom
import org.jetbrains.kotlinx.kandy.letsplot.layers.builders.interfaces.BarsBuilderInterface
import org.jetbrains.kotlinx.kandy.letsplot.layers.builders.subcontext.BorderLine
import org.jetbrains.kotlinx.statistics.kandy.statplots.models.HistogramPlot
import org.jetbrains.kotlinx.statistics.plotting.bin.models.WithStatBin
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*

@Suppress("INVISIBLE_MEMBER", "CANNOT_OVERRIDE_INVISIBLE_MEMBER", "INVISIBLE_REFERENCE")
public class HistogramPlotContext(
    private val histogramPlot: HistogramPlot
) : SingleLayerPlotBuilder(), BarsBuilderInterface,
    WithStatBin by histogramPlot.statBinFrame {
    override val datasetBuilder: DatasetBuilder = DatasetBuilderImpl(histogramPlot.statBinFrame)
    override val borderLine: BorderLine = BorderLine(bindingHandler)
    override val geom: Geom
        get() = BAR
    override val requiredAes: Set<Aes>
        get() = setOf(X, Y)
}
