package org.jetbrains.kotlinx.statistics.kandy.statplots.models

import org.jetbrains.kotlinx.kandy.dsl.plot
import org.jetbrains.kotlinx.kandy.ir.Plot
import org.jetbrains.kotlinx.statistics.kandy.layers.boxplot
import org.jetbrains.kotlinx.statistics.kandy.layers.boxplotGrouped
import org.jetbrains.kotlinx.statistics.plotting.boxplot.models.StatBoxplotFrame
import org.jetbrains.kotlinx.statistics.plotting.boxplot.models.StatBoxplotGroupBy
import org.jetbrains.kotlinx.statistics.plotting.boxplotOutliers.models.StatBoxplotOutliersFrame
import org.jetbrains.kotlinx.statistics.plotting.boxplotOutliers.models.StatBoxplotOutliersGroupBy

data class BoxplotStatGroupedPlot<T, X>(
    internal val statBoxplotGroupBy: StatBoxplotGroupBy<T, X>,
    internal val statBoxplotOutliersGroupBy: StatBoxplotOutliersGroupBy<T, X>,
    internal val xAxisName: String,
    internal val yAxisName: String,
    internal val showOutliers: Boolean,
): StatPlot {
    override fun toPlot(): Plot {
        return plot {
            boxplotGrouped(this, statBoxplotGroupBy, statBoxplotOutliersGroupBy, xAxisName, yAxisName) {
                outliers.show = showOutliers
            }
        }
    }

    constructor(
        boxesAndOutliers: Pair<StatBoxplotGroupBy<T, X>, StatBoxplotOutliersGroupBy<T, X>>,
        xAxisName: String,
        yAxisName: String,
        showOutliers: Boolean
    ) : this(boxesAndOutliers.first, boxesAndOutliers.second, xAxisName, yAxisName, showOutliers)
}