package org.jetbrains.kotlinx.statistics.kandy.statplots.models

import org.jetbrains.kotlinx.kandy.dsl.plot
import org.jetbrains.kotlinx.kandy.ir.Plot
import org.jetbrains.kotlinx.statistics.kandy.layers.boxplot
import org.jetbrains.kotlinx.statistics.plotting.boxplot.models.StatBoxplotFrame
import org.jetbrains.kotlinx.statistics.plotting.boxplotOutliers.models.StatBoxplotOutliersFrame

data class BoxplotStatPlot<X>(
    internal val statBoxplotFrame: StatBoxplotFrame<X>,
    internal val statBoxplotOutliersFrame: StatBoxplotOutliersFrame<X>,
    internal val xAxisName: String,
    internal val yAxisName: String,
    internal val showOutliers: Boolean,
): StatPlot {
    override fun toPlot(): Plot {
        return plot {
            boxplot(this, statBoxplotFrame, statBoxplotOutliersFrame, xAxisName, yAxisName) {
                outliers.show = showOutliers
            }
        }
    }

    constructor(
        boxesAndOutliers: Pair<StatBoxplotFrame<X>, StatBoxplotOutliersFrame<X>>,
        xAxisName: String,
        yAxisName: String,
        showOutliers: Boolean
    ) : this(boxesAndOutliers.first, boxesAndOutliers.second, xAxisName, yAxisName, showOutliers)
}