package org.jetbrains.kotlinx.statistics.kandy.statplots.models

import org.jetbrains.kotlinx.kandy.dsl.plot
import org.jetbrains.kotlinx.kandy.ir.Plot
import org.jetbrains.kotlinx.kandy.letsplot.y
import org.jetbrains.kotlinx.statistics.kandy.layers.candlestick
import org.jetbrains.kotlinx.statistics.plotting.candlestick.models.StatCandlestickFrame

data class CandlestickPlot<X>(
    internal val statCandlestickFrame: StatCandlestickFrame<X>,
    internal val xName: String,
    internal val yName: String,
): StatPlot {
    override fun toPlot(): Plot {
        return statCandlestickFrame.plot {
            candlestick(this, statCandlestickFrame, xName) {}
            y.axis.name = yName
        }
    }

}