package org.jetbrains.kotlinx.statistics.kandy.statplots.models

import org.jetbrains.kotlinx.kandy.dsl.plot
import org.jetbrains.kotlinx.kandy.ir.Plot
import org.jetbrains.kotlinx.kandy.letsplot.layers.bars
import org.jetbrains.kotlinx.kandy.letsplot.feature.Position
import org.jetbrains.kotlinx.kandy.letsplot.feature.position
import org.jetbrains.kotlinx.kandy.letsplot.x
import org.jetbrains.kotlinx.statistics.kandy.statplots.Stat
import org.jetbrains.kotlinx.statistics.plotting.count.models.StatCountGroupBy

data class CountGroupedPlot<T, X>(
    internal val statCountGroupBy: StatCountGroupBy<T, X>,
    internal val name: String,
    internal val weighted: Boolean,
): StatPlot {
    override fun toPlot(): Plot {
        return statCountGroupBy.plot {
            bars {
                x(Stat.x)
                if (weighted) {
                    y(Stat.countWeighted)
                } else {
                    y(Stat.count)
                }
                key.columnNames().singleOrNull()?.let {
                    fillColor(key[it])
                }
                position = Position.dodge()
            }
            x.axis.name = name
        }
    }
}
