package org.jetbrains.kotlinx.statistics.kandy.statplots.models

import org.jetbrains.kotlinx.kandy.dsl.plot
import org.jetbrains.kotlinx.kandy.ir.Plot
import org.jetbrains.kotlinx.kandy.letsplot.layers.bars
import org.jetbrains.kotlinx.kandy.letsplot.x
import org.jetbrains.kotlinx.statistics.kandy.statplots.Stat
import org.jetbrains.kotlinx.statistics.plotting.count.models.StatCountFrame

data class CountPlot<X>(
    internal val statCountFrame: StatCountFrame<X>,
    internal val name: String,
    internal val weighted: Boolean,
): StatPlot {
    override fun toPlot(): Plot {
        return statCountFrame.plot {
            bars {
                x(Stat.x)
                if (weighted) {
                    y(Stat.countWeighted)
                } else {
                    y(Stat.count)
                }
            }
            x.axis.name = name
        }
    }

}