package org.jetbrains.kotlinx.statistics.kandy.statplots.models

import org.jetbrains.kotlinx.kandy.dsl.plot
import org.jetbrains.kotlinx.kandy.ir.Plot
import org.jetbrains.kotlinx.statistics.kandy.layers.densityPlotGrouped
import org.jetbrains.kotlinx.statistics.plotting.density.models.StatDensityGroupBy

data class DensityGroupedPlot<T>(
    internal val statDensityGroupBy: StatDensityGroupBy<T>,
    internal val name: String,
    internal val weighted: Boolean,
): StatPlot {
    override fun toPlot(): Plot {
        return plot {
            densityPlotGrouped(this, statDensityGroupBy, name, weighted, {})
        }
    }
}
