package org.jetbrains.kotlinx.statistics.kandy.statplots.models

import org.jetbrains.kotlinx.kandy.dsl.plot
import org.jetbrains.kotlinx.kandy.ir.Plot
import org.jetbrains.kotlinx.statistics.kandy.layers.densityPlot
import org.jetbrains.kotlinx.statistics.plotting.density.models.StatDensityFrame
import org.jetbrains.kotlinx.statistics.kandy.layers.histogram

data class DensityPlot(
    internal val statDensityFrame: StatDensityFrame,
    internal val name: String,
    internal val weighted: Boolean,
): StatPlot {
    override fun toPlot(): Plot {
        return plot {
            densityPlot(this, statDensityFrame, name, weighted) {}
        }
    }
}