package org.jetbrains.kotlinx.statistics.kandy.statplots.models

import org.jetbrains.kotlinx.kandy.dsl.plot
import org.jetbrains.kotlinx.kandy.ir.Plot
import org.jetbrains.kotlinx.kandy.letsplot.layers.bars
import org.jetbrains.kotlinx.kandy.letsplot.layers.tiles
import org.jetbrains.kotlinx.kandy.letsplot.x
import org.jetbrains.kotlinx.kandy.letsplot.y
import org.jetbrains.kotlinx.statistics.kandy.statplots.Stat
import org.jetbrains.kotlinx.statistics.plotting.count2d.models.StatCount2DFrame

data class HeatmapPlot<X, Y>(
    internal val statCount2DFrame: StatCount2DFrame<X, Y>,
    internal val xName: String,
    internal val yName: String,
    internal val weighted: Boolean,
): StatPlot {
    override fun toPlot(): Plot {
        return statCount2DFrame.plot {
            tiles {
                x(Stat.x)
                y(Stat.y)
                if (weighted) {
                    fillColor(Stat.countWeighted)
                } else {
                    fillColor(Stat.count)
                }
            }
            x.axis.name = xName
            y.axis.name = yName
        }
    }

}