package org.jetbrains.kotlinx.statistics.kandy.statplots.models

import org.jetbrains.kotlinx.kandy.dsl.plot
import org.jetbrains.kotlinx.kandy.ir.Plot
import org.jetbrains.kotlinx.kandy.letsplot.layers.bars
import org.jetbrains.kotlinx.kandy.letsplot.feature.Position
import org.jetbrains.kotlinx.kandy.letsplot.feature.position
import org.jetbrains.kotlinx.kandy.letsplot.x
import org.jetbrains.kotlinx.statistics.kandy.layers.histogram
import org.jetbrains.kotlinx.statistics.kandy.layers.histogramGrouped
import org.jetbrains.kotlinx.statistics.kandy.statplots.Stat
import org.jetbrains.kotlinx.statistics.plotting.bin.models.StatBinGroupBy

data class HistogramGroupedPlot<T>(
    internal val statBinGroupBy: StatBinGroupBy<T>,
    internal val name: String,
    internal val weighted: Boolean,
): StatPlot {
    override fun toPlot(): Plot {
        return plot {
            histogramGrouped(this, statBinGroupBy, name, weighted, {})
        }
    }
}
