package org.jetbrains.kotlinx.statistics.kandy.statplots.models

import org.jetbrains.kotlinx.kandy.dsl.plot
import org.jetbrains.kotlinx.kandy.ir.Plot
import org.jetbrains.kotlinx.statistics.plotting.bin.models.StatBinFrame
import org.jetbrains.kotlinx.statistics.kandy.layers.histogram

data class HistogramPlot(
    internal val statBinFrame: StatBinFrame,
    internal val name: String,
    internal val weighted: Boolean,
): StatPlot {
    override fun toPlot(): Plot {
        return plot {
            histogram(this, statBinFrame, name, weighted) {}
        }
    }
}