package org.jetbrains.kotlinx.statistics.kandy.stattransform.context

import org.jetbrains.kotlinx.kandy.dsl.internal.LayerBuilderImpl
import org.jetbrains.kotlinx.kandy.dsl.internal.LayerCreatorScope
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*
import org.jetbrains.kotlinx.statistics.kandy.util.addDataset
import org.jetbrains.kotlinx.statistics.plotting.bin.models.StatBinGroupBy
import org.jetbrains.kotlinx.statistics.plotting.bin.models.WithStatBinGrouped
import org.jetbrains.kotlinx.statistics.plotting.bin.models.StatBinFrame
import org.jetbrains.kotlinx.statistics.plotting.bin.models.WithStatBin

public class StatBinLayerCreatorScope(
    df: StatBinFrame,
    parent: LayerCreatorScope,
) : StatScope(parent, NamedData(df)), WithStatBin by df

public class StatBinGroupedLayerCreatorScope<T>(
    gb: StatBinGroupBy<T>,
    parent: LayerCreatorScope,
) : StatScope(parent, GroupedData(gb)), WithStatBinGrouped<T> by gb
