package org.jetbrains.kotlinx.statistics.kandy.stattransform.context

import org.jetbrains.kotlinx.kandy.dsl.internal.LayerCreatorScope
import org.jetbrains.kotlinx.statistics.plotting.boxplot.models.StatBoxplotFrame
import org.jetbrains.kotlinx.statistics.plotting.boxplot.models.StatBoxplotGroupBy
import org.jetbrains.kotlinx.statistics.plotting.boxplot.models.WithStatBoxplot
import org.jetbrains.kotlinx.statistics.plotting.boxplot.models.WithStatBoxplotGrouped
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*

public class StatBoxplotLayerCreatorScope<X>(
    df: StatBoxplotFrame<X>,
    parent: LayerCreatorScope,
) : StatScope(parent, NamedData(df)), WithStatBoxplot<X> by df

public class StatBoxplotGroupedLayerCreatorScope<T, X>(
    private val gb: StatBoxplotGroupBy<T, X>,
    parent: LayerCreatorScope,
) : StatScope(parent, GroupedData(gb)), WithStatBoxplotGrouped<T, X> by gb
