package org.jetbrains.kotlinx.statistics.kandy.stattransform.context

import org.jetbrains.kotlinx.kandy.dsl.internal.LayerCreatorScope
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*
import org.jetbrains.kotlinx.statistics.plotting.boxplotOutliers.models.StatBoxplotOutliersFrame
import org.jetbrains.kotlinx.statistics.plotting.boxplotOutliers.models.StatBoxplotOutliersGroupBy
import org.jetbrains.kotlinx.statistics.plotting.boxplotOutliers.models.WithStatBoxplotOutliers
import org.jetbrains.kotlinx.statistics.plotting.boxplotOutliers.models.WithStatBoxplotOutliersGrouped


public class StatBoxplotOutliersLayerCreatorScope<X>(
    private val df: StatBoxplotOutliersFrame<X>,
    parent: LayerCreatorScope,
) : StatScope(parent, NamedData(df)), WithStatBoxplotOutliers<X> by df

public class StatBoxplotOutliersGroupedLayerCreatorScope<T, X>(
    private val gb: StatBoxplotOutliersGroupBy<T, X>,
    parent: LayerCreatorScope,
) : StatScope(parent, GroupedData(gb)), WithStatBoxplotOutliersGrouped<T, X> by gb
