package org.jetbrains.kotlinx.statistics.kandy.stattransform.context

import org.jetbrains.kotlinx.kandy.dsl.internal.LayerCreatorScope
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*
import org.jetbrains.kotlinx.statistics.plotting.count2d.models.StatCount2DFrame
import org.jetbrains.kotlinx.statistics.plotting.count2d.models.StatCount2DGroupBy
import org.jetbrains.kotlinx.statistics.plotting.count2d.models.WithStatCount2D
import org.jetbrains.kotlinx.statistics.plotting.count2d.models.WithStatCount2DGrouped

@Suppress("INVISIBLE_MEMBER")
public class StatCount2DLayerCreatorScope<X, Y>(
    private val df: StatCount2DFrame<X, Y>,
    parent: LayerCreatorScope,
) : StatScope(parent, NamedData(df)), WithStatCount2D<X, Y> by df

@Suppress("INVISIBLE_MEMBER")
public class StatCount2DGroupedLayerCreatorScope<T, X, Y>(
    private val gb: StatCount2DGroupBy<T, X, Y>,
    parent: LayerCreatorScope,
) : StatScope(parent, GroupedData(gb)), WithStatCount2DGrouped<T, X, Y> by gb
