package org.jetbrains.kotlinx.statistics.kandy.stattransform.context

import org.jetbrains.kotlinx.kandy.dsl.internal.LayerCreatorScope
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*
import org.jetbrains.kotlinx.statistics.plotting.count.models.StatCountFrame
import org.jetbrains.kotlinx.statistics.plotting.count.models.StatCountGroupBy
import org.jetbrains.kotlinx.statistics.plotting.count.models.WithStatCount
import org.jetbrains.kotlinx.statistics.plotting.count.models.WithStatCountGrouped


public class StatCountLayerCreatorScope<X>(
    df: StatCountFrame<X>,
    parent: LayerCreatorScope,
) : StatScope(parent, NamedData(df)), WithStatCount<X> by df

public class StatCountGroupedLayerCreatorScope<T, X>(
    gb: StatCountGroupBy<T, X>,
    parent: LayerCreatorScope,
) : StatScope(parent, GroupedData(gb)), WithStatCountGrouped<T, X> by gb
