package org.jetbrains.kotlinx.statistics.kandy.stattransform.context

import org.jetbrains.kotlinx.kandy.dsl.internal.LayerCreatorScope
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*
import org.jetbrains.kotlinx.statistics.plotting.density.models.StatDensityFrame
import org.jetbrains.kotlinx.statistics.plotting.density.models.StatDensityGroupBy
import org.jetbrains.kotlinx.statistics.plotting.density.models.WithStatDensity
import org.jetbrains.kotlinx.statistics.plotting.density.models.WithStatDensityGrouped


public class StatDensityLayerCreatorScope(
    private val df: StatDensityFrame,
    parent: LayerCreatorScope,
) : StatScope(parent, NamedData(df)), WithStatDensity by df

public class StatDensityGroupedLayerCreatorScope<T>(
    private val gb: StatDensityGroupBy<T>,
    parent: LayerCreatorScope,
) : StatScope(parent, GroupedData(gb)), WithStatDensityGrouped<T> by gb
