package org.jetbrains.kotlinx.statistics.kandy.stattransform.context

import org.jetbrains.kotlinx.kandy.dsl.internal.LayerCreatorScope
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*
import org.jetbrains.kotlinx.statistics.plotting.smooth.models.StatSmoothFrame
import org.jetbrains.kotlinx.statistics.plotting.smooth.models.StatSmoothGroupBy
import org.jetbrains.kotlinx.statistics.plotting.smooth.models.WithStatSmooth
import org.jetbrains.kotlinx.statistics.plotting.smooth.models.WithStatSmoothGrouped


public class StatSmoothLayerCreatorScope(
    df: StatSmoothFrame,
    parent: LayerCreatorScope,
) : StatScope(parent, NamedData(df)), WithStatSmooth by df

public class StatSmoothGroupedLayerCreatorScope<T>(
    gb: StatSmoothGroupBy<T>,
    parent: LayerCreatorScope,
) : StatScope(parent, GroupedData(gb)), WithStatSmoothGrouped<T> by gb
