package org.jetbrains.kotlinx.statistics.kandy.stattransform

import org.jetbrains.kotlinx.dataframe.DataColumn
import org.jetbrains.kotlinx.dataframe.columns.ColumnAccessor
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*
import org.jetbrains.kotlinx.kandy.letsplot.internal.*
import org.jetbrains.kotlinx.statistics.binning.BinsAlign
import org.jetbrains.kotlinx.statistics.binning.BinsOption
import org.jetbrains.kotlinx.statistics.kandy.stattransform.context.StatBinLayerCreatorScope
import org.jetbrains.kotlinx.statistics.plotting.bin.statBin
import org.jetbrains.kotlinx.statistics.kandy.get

@Suppress("INVISIBLE_MEMBER")
public fun DataFramePlotBuilder<*>.statBin(
    x: Iterable<Number>,
    weights: Iterable<Number>? = null,
    binsOption: BinsOption = BinsOption.byNumber(20),
    binsAlign: BinsAlign = BinsAlign.center(0.0),
    block: StatBinLayerCreatorScope.() -> Unit
) {
    val statBinFrame = statBin(x, weights, binsOption, binsAlign)
    StatBinLayerCreatorScope(statBinFrame, this).apply(block)
}

@Suppress("INVISIBLE_MEMBER")
public fun DataFramePlotBuilder<*>.statBin(
    x: DataColumn<Number>,
    weights: DataColumn<Number>? = null,
    binsOption: BinsOption = BinsOption.byNumber(20),
    binsAlign: BinsAlign = BinsAlign.center(0.0),
    block: StatBinLayerCreatorScope.() -> Unit
) {
    val statBinFrame = statBin(x, weights, binsOption, binsAlign)
    StatBinLayerCreatorScope(statBinFrame, this).apply(block)
}

@Suppress("INVISIBLE_MEMBER")
public  fun DataFramePlotBuilder<*>.statBin(
    x: ColumnAccessor<Number>,
    weights: ColumnAccessor<Number>? = null,
    binsOption: BinsOption = BinsOption.byNumber(20),
    binsAlign: BinsAlign = BinsAlign.center(0.0),
    block: StatBinLayerCreatorScope.() -> Unit
) {
    val statBinFrame = statBin(datasetBuilderImpl.get(x), weights?.let { datasetBuilderImpl.get(it)}, binsOption, binsAlign)
    StatBinLayerCreatorScope(statBinFrame, this).apply(block)
}

@Suppress("INVISIBLE_MEMBER")
public  fun DataFramePlotBuilder<*>.statBin(
    x: String,
    weights: String? = null,
    binsOption: BinsOption = BinsOption.byNumber(20),
    binsAlign: BinsAlign = BinsAlign.center(0.0),
    block: StatBinLayerCreatorScope.() -> Unit
) {
    val statBinFrame = statBin(datasetBuilderImpl.get(x) as DataColumn<Number>, weights?.let { datasetBuilderImpl.get(it) as DataColumn<Number>} , binsOption, binsAlign)
    StatBinLayerCreatorScope(statBinFrame, this).apply(block)
}
