package org.jetbrains.kotlinx.statistics.kandy.stattransform

import org.jetbrains.kotlinx.dataframe.DataColumn
import org.jetbrains.kotlinx.dataframe.api.*
import org.jetbrains.kotlinx.dataframe.columns.ColumnAccessor
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.GroupedDataScope
import org.jetbrains.kotlinx.kandy.dsl.internal.LayerCreatorScope
import org.jetbrains.kotlinx.statistics.binning.BinsAlign
import org.jetbrains.kotlinx.statistics.binning.BinsOption
import org.jetbrains.kotlinx.statistics.plotting.bin.statBin
import  org.jetbrains.kotlinx.statistics.kandy.stattransform.context.*
import org.jetbrains.kotlinx.statistics.kandy.util.internalGroupBy

@Suppress("INVISIBLE_MEMBER")
public fun <T> GroupedDataScope<T, *>.statBin(
    x: DataColumn<Number>,
    weights: DataColumn<Number>? = null,
    binsOption: BinsOption = BinsOption.byNumber(20),
    binsAlign: BinsAlign = BinsAlign.center(0.0),
    block: StatBinGroupedLayerCreatorScope<T>.() -> Unit
) {
    val groupBy = internalGroupBy as GroupBy<T, *>
    val statBinGrouped = groupBy.statBin(x, weights, binsOption, binsAlign)
    StatBinGroupedLayerCreatorScope(statBinGrouped, this as LayerCreatorScope).apply(block)
}

@Suppress("INVISIBLE_MEMBER")
public  fun <T> GroupedDataScope<T, *>.statBin(
    x: ColumnAccessor<Number>,
    weights: ColumnAccessor<Number>? = null,
    binsOption: BinsOption = BinsOption.byNumber(20),
    binsAlign: BinsAlign = BinsAlign.center(0.0),
    block: StatBinGroupedLayerCreatorScope<T>.() -> Unit
) {
    val groupBy =  internalGroupBy as GroupBy<T, *>
    val statBinGrouped = groupBy.statBin(x, weights, binsOption, binsAlign)
    StatBinGroupedLayerCreatorScope(statBinGrouped, this as LayerCreatorScope).apply(block)
}

@Suppress("INVISIBLE_MEMBER")
public fun <T> GroupedDataScope<T, *>.statBin(
    x: String,
    weights: String? = null,
    binsOption: BinsOption = BinsOption.byNumber(20),
    binsAlign: BinsAlign = BinsAlign.center(0.0),
    block: StatBinGroupedLayerCreatorScope<T>.() -> Unit
) {
   return this.statBin(column(x),weights?.let { column(it) }, binsOption, binsAlign, block)
}
