package org.jetbrains.kotlinx.statistics.kandy.stattransform

import org.jetbrains.kotlinx.dataframe.DataColumn
import org.jetbrains.kotlinx.dataframe.api.column
import org.jetbrains.kotlinx.dataframe.columns.ColumnAccessor
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.GroupedDataScope
import org.jetbrains.kotlinx.kandy.dsl.internal.LayerCreatorScope
import org.jetbrains.kotlinx.statistics.kandy.stattransform.context.StatBoxplotGroupedLayerCreatorScope
import org.jetbrains.kotlinx.statistics.kandy.util.internalGroupBy
import org.jetbrains.kotlinx.statistics.plotting.boxplot.statBoxplot

public inline fun<T, X> GroupedDataScope<T, *>.statBoxplot(
    x: DataColumn<X>,
    y: DataColumn<Number>,
    whiskerIQRRatio: Double = 1.5,
    block: StatBoxplotGroupedLayerCreatorScope<T, X>.() -> Unit
) {
    val statBoxplotFrame = internalGroupBy.statBoxplot(x, y, whiskerIQRRatio)
    StatBoxplotGroupedLayerCreatorScope(statBoxplotFrame, this as LayerCreatorScope).apply(block)
}

@Suppress("INVISIBLE_MEMBER")
public inline fun<T, X> GroupedDataScope<T, *>.statBoxplot(
    x: ColumnAccessor<X>,
    y: ColumnAccessor<Number>,
    whiskerIQRRatio: Double = 1.5,
    block: StatBoxplotGroupedLayerCreatorScope<T, X>.() -> Unit
) {
    val statBoxplotFrame = internalGroupBy.statBoxplot(x, y, whiskerIQRRatio)
    StatBoxplotGroupedLayerCreatorScope(statBoxplotFrame, this as LayerCreatorScope).apply(block)
}

@Suppress("INVISIBLE_MEMBER")
public inline fun<T> GroupedDataScope<T, *>.statBoxplot(
    x: String,
    y: String,
    whiskerIQRRatio: Double = 1.5,
    block: StatBoxplotGroupedLayerCreatorScope<T, Any?>.() -> Unit
) {
    val statBoxplotFrame = internalGroupBy.statBoxplot(column<Any?>(x), column(y), whiskerIQRRatio)
    StatBoxplotGroupedLayerCreatorScope(statBoxplotFrame, this as LayerCreatorScope).apply(block)
}
