package org.jetbrains.kotlinx.statistics.kandy.stattransform

import org.jetbrains.kotlinx.dataframe.DataColumn
import org.jetbrains.kotlinx.dataframe.api.column
import org.jetbrains.kotlinx.dataframe.columns.ColumnAccessor
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.GroupedDataScope
import org.jetbrains.kotlinx.kandy.dsl.internal.LayerCreatorScope
import org.jetbrains.kotlinx.statistics.kandy.stattransform.context.StatBoxplotOutliersGroupedLayerCreatorScope
import org.jetbrains.kotlinx.statistics.kandy.util.internalGroupBy
import org.jetbrains.kotlinx.statistics.plotting.boxplotOutliers.statBoxplotOutliers

public inline fun<T, X> GroupedDataScope<T, *>.statBoxplotOutliers(
    x: DataColumn<X>,
    y: DataColumn<Number>,
    whiskerIQRRatio: Double = 1.5,
    block: StatBoxplotOutliersGroupedLayerCreatorScope<T, X>.() -> Unit
) {
    val statBoxplotOutliersFrame = internalGroupBy.statBoxplotOutliers(x, y, whiskerIQRRatio)
    StatBoxplotOutliersGroupedLayerCreatorScope(statBoxplotOutliersFrame, this as LayerCreatorScope).apply(block)
}

@Suppress("INVISIBLE_MEMBER")
public inline fun<T, X> GroupedDataScope<T, *>.statBoxplotOutliers(
    x: ColumnAccessor<X>,
    y: ColumnAccessor<Number>,
    whiskerIQRRatio: Double = 1.5,
    block: StatBoxplotOutliersGroupedLayerCreatorScope<T, X>.() -> Unit
) {
    val statBoxplotOutliersFrame = internalGroupBy.statBoxplotOutliers(x, y, whiskerIQRRatio)
    StatBoxplotOutliersGroupedLayerCreatorScope(statBoxplotOutliersFrame, this as LayerCreatorScope).apply(block)
}

@Suppress("INVISIBLE_MEMBER")
public inline fun<T> GroupedDataScope<T, *>.statBoxplotOutliers(
    x: String,
    y: String,
    whiskerIQRRatio: Double = 1.5,
    block: StatBoxplotOutliersGroupedLayerCreatorScope<T, Any?>.() -> Unit
) {
    val statBoxplotOutliersFrame = internalGroupBy.statBoxplotOutliers(column<Any?>(x), column(y), whiskerIQRRatio)
    StatBoxplotOutliersGroupedLayerCreatorScope(statBoxplotOutliersFrame, this as LayerCreatorScope).apply(block)
}
