package org.jetbrains.kotlinx.statistics.kandy.stattransform

import org.jetbrains.kotlinx.dataframe.DataColumn
import org.jetbrains.kotlinx.dataframe.DataFrame
import org.jetbrains.kotlinx.dataframe.columns.ColumnAccessor
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.DataFramePlotBuilder
import org.jetbrains.kotlinx.statistics.kandy.stattransform.context.StatCandlestickLayerCreatorScope
import org.jetbrains.kotlinx.statistics.kandy.util.internalDataFrame
import org.jetbrains.kotlinx.statistics.plotting.candlestick.statCandlestick

@Suppress("INVISIBLE_MEMBER")
public fun<X> DataFramePlotBuilder<*>.statCandlestick(
    x: Iterable<X>,
    open: Iterable<Number>,
    high: Iterable<Number>,
    low: Iterable<Number>,
    close: Iterable<Number>,
    block: StatCandlestickLayerCreatorScope<X>.() -> Unit
) {
    val statCandlestickFrame = statCandlestick(x, open, high, low, close)
    StatCandlestickLayerCreatorScope(statCandlestickFrame, this).apply(block)
}

@Suppress("INVISIBLE_MEMBER")
public fun<X> DataFramePlotBuilder<*>.statCandlestick(
    x: ColumnAccessor<X>,
    open: ColumnAccessor<Number>,
    high: ColumnAccessor<Number>,
    low: ColumnAccessor<Number>,
    close: ColumnAccessor<Number>,
    block: StatCandlestickLayerCreatorScope<X>.() -> Unit
) {
    val statCandlestickFrame = internalDataFrame.statCandlestick(x, open, high, low, close)
    StatCandlestickLayerCreatorScope(statCandlestickFrame, this).apply(block)
}

@Suppress("INVISIBLE_MEMBER")
public  fun <X> DataFramePlotBuilder<*>.statCandlestick(
    x: DataColumn<X>,
    open: DataColumn<Number>,
    high: DataColumn<Number>,
    low: DataColumn<Number>,
    close: DataColumn<Number>,
    block: StatCandlestickLayerCreatorScope<X>.() -> Unit
) {
    val statCandlestickFrame = statCandlestick(x, open, high, low, close)
    StatCandlestickLayerCreatorScope(statCandlestickFrame, this).apply(block)
}

@Suppress("INVISIBLE_MEMBER")
public fun DataFramePlotBuilder<*>.statCandlestick(
    x: String,
    open: String,
    high: String,
    low: String,
    close: String,
    block: StatCandlestickLayerCreatorScope<Any?>.() -> Unit
) {
    val statCandlestickFrame = internalDataFrame.statCandlestick(x, open, high, low, close)
    StatCandlestickLayerCreatorScope(statCandlestickFrame, this).apply(block)
}
