package org.jetbrains.kotlinx.statistics.kandy.stattransform

import org.jetbrains.kotlinx.dataframe.DataColumn
import org.jetbrains.kotlinx.dataframe.columns.ColumnAccessor
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.GroupedDataScope
import org.jetbrains.kotlinx.kandy.dsl.internal.LayerCreatorScope
import org.jetbrains.kotlinx.statistics.kandy.stattransform.context.StatCount2DGroupedLayerCreatorScope
import org.jetbrains.kotlinx.statistics.kandy.util.internalGroupBy
import org.jetbrains.kotlinx.statistics.plotting.count2d.statCount2D

@Suppress("INVISIBLE_MEMBER")
public fun <T, X, Y> GroupedDataScope<T, *>.statCount2D(
    x: DataColumn<X>,
    y: DataColumn<Y>,
    weights: DataColumn<Number>? = null,
    block: StatCount2DGroupedLayerCreatorScope<T, X, Y>.() -> Unit
) {
    val groupBy = internalGroupBy
    val statCount2DGrouped = groupBy.statCount2D(x, y, weights)
    StatCount2DGroupedLayerCreatorScope(statCount2DGrouped, this as LayerCreatorScope).apply(block)
}

@Suppress("INVISIBLE_MEMBER")
public  fun <T, X, Y> GroupedDataScope<T, *>.statCount2D(
    x: ColumnAccessor<X>,
    y: ColumnAccessor<Y>,
    weights: ColumnAccessor<Number>? = null,
    block: StatCount2DGroupedLayerCreatorScope<T, X, Y>.() -> Unit
) {
    val groupBy = internalGroupBy
    val statCount2DGrouped = groupBy.statCount2D(x, y, weights)
    StatCount2DGroupedLayerCreatorScope(statCount2DGrouped, this as LayerCreatorScope).apply(block)
}

@Suppress("INVISIBLE_MEMBER")
public fun <T> GroupedDataScope<T, *>.statCount2D(
    x: String,
    y: String,
    weights: String? = null,
    block: StatCount2DGroupedLayerCreatorScope<T, Any?, Any?>.() -> Unit
) {
    val groupBy = internalGroupBy
    val statCount2DGrouped = groupBy.statCount2D(x, y, weights)
    StatCount2DGroupedLayerCreatorScope(statCount2DGrouped, this as LayerCreatorScope).apply(block)
}
