package org.jetbrains.kotlinx.statistics.kandy.stattransform

import org.jetbrains.kotlinx.dataframe.DataColumn
import org.jetbrains.kotlinx.dataframe.columns.ColumnAccessor
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.GroupedDataScope
import org.jetbrains.kotlinx.kandy.dsl.internal.LayerCreatorScope
import org.jetbrains.kotlinx.statistics.kandy.stattransform.context.StatCountGroupedLayerCreatorScope
import org.jetbrains.kotlinx.statistics.kandy.util.internalGroupBy
import org.jetbrains.kotlinx.statistics.plotting.count.statCount

@Suppress("INVISIBLE_MEMBER")
public fun <T, X> GroupedDataScope<T, *>.statCount(
    sample: DataColumn<X>,
    weights: DataColumn<Number>? = null,
    block: StatCountGroupedLayerCreatorScope<T, X>.() -> Unit
) {
    val groupBy = internalGroupBy
    val statCountGrouped = groupBy.statCount(sample, weights)
    StatCountGroupedLayerCreatorScope(statCountGrouped, this as LayerCreatorScope).apply(block)
}

@Suppress("INVISIBLE_MEMBER")
public  fun <T, X> GroupedDataScope<T, *>.statCount(
    sample: ColumnAccessor<X>,
    weights: ColumnAccessor<Number>? = null,
    block: StatCountGroupedLayerCreatorScope<T, X>.() -> Unit
) {
    val groupBy = internalGroupBy
    val statCountGrouped = groupBy.statCount(sample, weights)
    StatCountGroupedLayerCreatorScope(statCountGrouped, this as LayerCreatorScope).apply(block)
}

@Suppress("INVISIBLE_MEMBER")
public fun <T> GroupedDataScope<T, *>.statCount(
    sample: String,
    weights: String? = null,
    block: StatCountGroupedLayerCreatorScope<T, Any?>.() -> Unit
) {
    val groupBy = internalGroupBy
    val statCountGrouped = groupBy.statCount(sample, weights)
    StatCountGroupedLayerCreatorScope(statCountGrouped, this as LayerCreatorScope).apply(block)
}
