package org.jetbrains.kotlinx.statistics.kandy.stattransform

import org.jetbrains.kotlinx.dataframe.DataColumn
import org.jetbrains.kotlinx.dataframe.api.*
import org.jetbrains.kotlinx.dataframe.columns.ColumnAccessor
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.GroupedDataScope
import org.jetbrains.kotlinx.kandy.dsl.internal.LayerCreatorScope
import org.jetbrains.kotlinx.statistics.kandy.stattransform.context.*
import org.jetbrains.kotlinx.statistics.kandy.util.internalGroupBy
import org.jetbrains.kotlinx.statistics.plotting.smooth.SmoothMethod
import org.jetbrains.kotlinx.statistics.plotting.smooth.statSmooth

@Suppress("INVISIBLE_MEMBER")
public fun <T> GroupedDataScope<T, *>.statSmooth(
    x: DataColumn<Number>,
    y: DataColumn<Number>,
    method: SmoothMethod = SmoothMethod.LOESS(),
    smootherPointCount: Int = 100,
    block: StatSmoothGroupedLayerCreatorScope<T>.() -> Unit
) {
    val groupBy = internalGroupBy
    val statSmoothGrouped = groupBy.statSmooth(x, y, method, smootherPointCount)
    StatSmoothGroupedLayerCreatorScope(statSmoothGrouped, this as LayerCreatorScope).apply(block)
}

@Suppress("INVISIBLE_MEMBER")
public fun <T> GroupedDataScope<T, *>.statSmooth(
    x: ColumnAccessor<Number>,
    y: ColumnAccessor<Number>,
    method: SmoothMethod = SmoothMethod.LOESS(),
    smootherPointCount: Int = 100,
    block: StatSmoothGroupedLayerCreatorScope<T>.() -> Unit
) {
    val groupBy = internalGroupBy
    val statSmoothGrouped = groupBy.statSmooth(x, y, method, smootherPointCount)
    StatSmoothGroupedLayerCreatorScope(statSmoothGrouped, this as LayerCreatorScope).apply(block)
}

@Suppress("INVISIBLE_MEMBER")
public fun <T> GroupedDataScope<T, *>.statSmooth(
    x: String,
    y: String,
    method: SmoothMethod = SmoothMethod.LOESS(),
    smootherPointCount: Int = 100,
    block: StatSmoothGroupedLayerCreatorScope<T>.() -> Unit
) {
    val groupBy = internalGroupBy as GroupBy<T, *>
    val statSmoothGrouped = groupBy.statSmooth(x, y, method, smootherPointCount)
    StatSmoothGroupedLayerCreatorScope(statSmoothGrouped, this  as LayerCreatorScope).apply(block)
}
