package org.jetbrains.kotlinx.statistics.kandy

import org.jetbrains.kotlinx.dataframe.DataColumn
import org.jetbrains.kotlinx.dataframe.columns.ColumnAccessor
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*
import kotlin.reflect.KProperty


@PublishedApi
@Suppress("INVISIBLE_REFERENCE", "INVISIBLE_MEMBER")
internal fun<T> DatasetBuilderImpl.get(column: ColumnAccessor<T>): DataColumn<T> {
    return baseDataFrame[column]
}

@PublishedApi
@Suppress("INVISIBLE_REFERENCE", "INVISIBLE_MEMBER")
internal fun<T> DatasetBuilderImpl.get(column: KProperty<T>): DataColumn<T> {
    return baseDataFrame[column]
}

@PublishedApi
@Suppress("INVISIBLE_REFERENCE", "INVISIBLE_MEMBER")
internal fun DatasetBuilderImpl.get(column: String): DataColumn<*> {
    return baseDataFrame[column]
}
