package org.jetbrains.kotlinx.statistics.kandy.util

import org.jetbrains.kotlinx.dataframe.api.GroupBy
import org.jetbrains.kotlinx.kandy.dsl.internal.*
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*

@PublishedApi
@Suppress("INVISIBLE_MEMBER", "INVISIBLE_REFERENCE")
internal val LayerCreatorScope.internalDataFrame
    get() = (datasetBuilder as DatasetBuilderImpl).baseDataFrame

@PublishedApi
@Suppress("INVISIBLE_MEMBER")
internal val <T> GroupedDataScope<T, *>.internalGroupBy: GroupBy<T, *>
    get() = when(this) {
        is GroupByPlotBuilder<T, *> -> groupBy
        is GroupByScope<T, *> -> groupBy
    }
