package org.jetbrains.kotlinx.statistics.plotting.bin.models

import org.jetbrains.kotlinx.dataframe.ColumnsContainer
import org.jetbrains.kotlinx.dataframe.api.*
import org.jetbrains.kotlinx.dataframe.columns.ColumnGroup
import org.jetbrains.kotlinx.kandy.dsl.internal.*
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*


class StatBinGroupBy<T>(private val groupBy: GroupBy<T, StatBin>) :
    GroupBy<T, StatBin> by groupBy, ColumnsContainer<StatBin> by groupBy.groups.concat(),
    WithStatBinGrouped<T> {

    override val Stat =
        WithStatBin.StatHolder(groupBy.groups.concat()["Stat"].asColumnGroup() as ColumnGroup<BinStatistics>)

    @Suppress("INVISIBLE_MEMBER")
    override val key: ColumnGroup<T> =
        groupBy.concatFixed().getColumns(*keys.columnNames().toTypedArray()).toColumnGroup(
            "key"
        ) as ColumnGroup<T>

}