package org.jetbrains.kotlinx.statistics.plotting.bin.models

import org.jetbrains.kotlinx.dataframe.ColumnsContainer
import org.jetbrains.kotlinx.dataframe.DataColumn
import org.jetbrains.kotlinx.dataframe.columns.ColumnGroup

interface WithStatBin : ColumnsContainer<StatBin> {
    val Stat: StatHolder

    class StatHolder(private val cg: ColumnGroup<BinStatistics>): ColumnGroup<BinStatistics> by cg {
        val x: DataColumn<Double> = cg["x"] as DataColumn<Double>
        val count: DataColumn<Int> = cg["count"] as DataColumn<Int>
        val countWeighted: DataColumn<Double> = cg["countWeighted"] as DataColumn<Double>
        val density: DataColumn<Double> = cg["density"] as DataColumn<Double>
        val densityWeighted: DataColumn<Double> = cg["densityWeighted"] as DataColumn<Double>
    }
}
