package org.jetbrains.kotlinx.statistics.plotting.boxplot.models

import org.jetbrains.kotlinx.dataframe.DataFrame
import org.jetbrains.kotlinx.dataframe.api.asColumnGroup
import org.jetbrains.kotlinx.dataframe.api.dataFrameOf
import org.jetbrains.kotlinx.dataframe.api.inferType
import org.jetbrains.kotlinx.dataframe.api.toDataFrame
import org.jetbrains.kotlinx.dataframe.columns.ColumnGroup

class StatBoxplotFrame<T>(private val df: DataFrame<StatBoxplot<T>>)
    : DataFrame<StatBoxplot<T>> by df, WithStatBoxplot<T> {

    public override val Stat: WithStatBoxplot.StatHolder<T> = WithStatBoxplot.StatHolder(df["Stat"].asColumnGroup() as ColumnGroup<BoxplotStatistics<T>>)

    companion object {
        fun<T> fromList(list: List<BoxplotStatistics<T>>): StatBoxplotFrame<T> {
            return StatBoxplotFrame<T>(dataFrameOf(list.toDataFrame().inferType("x").asColumnGroup("Stat")) as  DataFrame<StatBoxplot<T>>)
        }
    }
}
