package org.jetbrains.kotlinx.statistics.plotting.boxplot.models

import org.jetbrains.kotlinx.dataframe.ColumnsContainer
import org.jetbrains.kotlinx.dataframe.api.*
import org.jetbrains.kotlinx.dataframe.columns.ColumnGroup
import org.jetbrains.kotlinx.kandy.dsl.internal.*
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*


class StatBoxplotGroupBy<T, X>(private val groupBy: GroupBy<T, StatBoxplot<X>>) :
    GroupBy<T, StatBoxplot<X>> by groupBy, ColumnsContainer<StatBoxplot<X>> by groupBy.groups.concat(),
    WithStatBoxplotGrouped<T, X> {

    override val Stat =
        WithStatBoxplot.StatHolder<X>(groupBy.groups.concat()["Stat"].asColumnGroup() as ColumnGroup<BoxplotStatistics<X>>)

    @Suppress("INVISIBLE_MEMBER")
    override val key: ColumnGroup<T> =
        groupBy.concatFixed().getColumns(*keys.columnNames().toTypedArray()).toColumnGroup(
            "key"
        ) as ColumnGroup<T>

}