package org.jetbrains.kotlinx.statistics.plotting.boxplot.models

import org.jetbrains.kotlinx.dataframe.ColumnsContainer
import org.jetbrains.kotlinx.dataframe.DataColumn
import org.jetbrains.kotlinx.dataframe.columns.ColumnGroup

interface WithStatBoxplot<T>: ColumnsContainer<StatBoxplot<T>> {
    public val Stat: StatHolder<T>

    public class StatHolder<T>(private val cg: ColumnGroup<BoxplotStatistics<T>>): ColumnGroup<BoxplotStatistics<T>> by cg {
        val x: DataColumn<T> = cg["x"] as DataColumn<T>
        val min: DataColumn<Double> = cg["min"] as DataColumn<Double>
        val lower: DataColumn<Double> = cg["lower"] as DataColumn<Double>
        val middle: DataColumn<Double> = cg["middle"] as DataColumn<Double>
        val upper: DataColumn<Double> = cg["upper"] as DataColumn<Double>
        val max: DataColumn<Double> = cg["max"] as DataColumn<Double>
    }
}