package org.jetbrains.kotlinx.statistics.plotting.boxplotOutliers.models

import org.jetbrains.kotlinx.dataframe.DataFrame
import org.jetbrains.kotlinx.dataframe.api.asColumnGroup
import org.jetbrains.kotlinx.dataframe.api.dataFrameOf
import org.jetbrains.kotlinx.dataframe.api.inferType
import org.jetbrains.kotlinx.dataframe.api.toDataFrame
import org.jetbrains.kotlinx.dataframe.columns.ColumnGroup

class StatBoxplotOutliersFrame<T>(private val df: DataFrame<StatBoxplotOutliers<T>>) :
    DataFrame<StatBoxplotOutliers<T>> by df, WithStatBoxplotOutliers<T> {


    public override val Stat: WithStatBoxplotOutliers.StatHolder<T> =
        WithStatBoxplotOutliers.StatHolder(df["Stat"].asColumnGroup() as ColumnGroup<BoxplotOutliersStatistics<T>>)


    companion object {
        fun <T> fromList(list: List<List<BoxplotOutliersStatistics<T>>>): StatBoxplotOutliersFrame<T> {
            return StatBoxplotOutliersFrame<T>(
                dataFrameOf(
                    list.flatten().toDataFrame().inferType("x").asColumnGroup("Stat")
                ) as DataFrame<StatBoxplotOutliers<T>>
            )
        }
    }
}