package org.jetbrains.kotlinx.statistics.plotting.boxplotOutliers.models

import org.jetbrains.kotlinx.dataframe.ColumnsContainer
import org.jetbrains.kotlinx.dataframe.api.*
import org.jetbrains.kotlinx.dataframe.columns.ColumnGroup
import org.jetbrains.kotlinx.kandy.dsl.internal.*
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*


class StatBoxplotOutliersGroupBy<T, X>(private val groupBy: GroupBy<T, StatBoxplotOutliers<X>>) :
    GroupBy<T, StatBoxplotOutliers<X>> by groupBy, ColumnsContainer<StatBoxplotOutliers<X>> by groupBy.groups.concat(),
    WithStatBoxplotOutliersGrouped<T, X> {

    override val Stat =
        WithStatBoxplotOutliers.StatHolder<X>(groupBy.groups.concat()["Stat"].asColumnGroup() as ColumnGroup<BoxplotOutliersStatistics<X>>)

    @Suppress("INVISIBLE_MEMBER")
    override val key: ColumnGroup<T> =
        groupBy.concatFixed().getColumns(*keys.columnNames().toTypedArray()).toColumnGroup(
            "key"
        ) as ColumnGroup<T>

}