package org.jetbrains.kotlinx.statistics.plotting.candlestick.models

import org.jetbrains.kotlinx.dataframe.ColumnsContainer
import org.jetbrains.kotlinx.dataframe.DataColumn
import org.jetbrains.kotlinx.dataframe.columns.ColumnGroup

interface WithStatCandlestick<T> : ColumnsContainer<StatCandlestick<T>> {
    val Stat: StatHolder<T>

    class StatHolder<T>(private val cg: ColumnGroup<CandlestickStatistics<T>>): ColumnGroup<CandlestickStatistics<T>> by cg {
        val x: DataColumn<T> = cg["x"] as DataColumn<T>
        val open: DataColumn<Double> = cg["open"] as DataColumn<Double>
        val close: DataColumn<Double> = cg["close"] as DataColumn<Double>
        val min: DataColumn<Double> = cg["min"] as DataColumn<Double>
        val lower: DataColumn<Double> = cg["lower"] as DataColumn<Double>
        val upper: DataColumn<Double> = cg["upper"] as DataColumn<Double>
        val max: DataColumn<Double> = cg["max"] as DataColumn<Double>
        val isIncreased: DataColumn<Boolean> = cg["isIncreased"] as DataColumn<Boolean>
    }
}
