package org.jetbrains.kotlinx.statistics.plotting.count.models

import org.jetbrains.kotlinx.dataframe.ColumnsContainer
import org.jetbrains.kotlinx.dataframe.api.*
import org.jetbrains.kotlinx.dataframe.columns.ColumnGroup
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*


class StatCountGroupBy<T, X>(private val groupBy: GroupBy<T, StatCount<X>>) :
    GroupBy<T, StatCount<X>> by groupBy, ColumnsContainer<StatCount<X>> by groupBy.groups.concat(),
    WithStatCountGrouped<T, X> {

    override val Stat =
        WithStatCount.StatHolder<X>(groupBy.groups.concat()["Stat"].asColumnGroup() as ColumnGroup<CountStatistics<X>>)

    @Suppress("INVISIBLE_MEMBER")
    override val key: ColumnGroup<T> =
        groupBy.concatFixed().getColumns(*keys.columnNames().toTypedArray()).toColumnGroup(
            "key"
        ) as ColumnGroup<T>
}