package org.jetbrains.kotlinx.statistics.plotting.count.models

import org.jetbrains.kotlinx.dataframe.ColumnsContainer
import org.jetbrains.kotlinx.dataframe.DataColumn
import org.jetbrains.kotlinx.dataframe.columns.ColumnGroup

interface WithStatCount<T>: ColumnsContainer<StatCount<T>> {
    public val Stat: StatHolder<T>

    public class StatHolder<T>(private val cg: ColumnGroup<CountStatistics<T>>): ColumnGroup<CountStatistics<T>> by cg {
        val x: DataColumn<T> = cg["x"] as DataColumn<T>
        val count: DataColumn<Int> = cg["count"] as DataColumn<Int>
        val countWeighted: DataColumn<Double> = cg["countWeighted"] as DataColumn<Double>
    }
}