package org.jetbrains.kotlinx.statistics.plotting.count2d.models

import org.jetbrains.kotlinx.dataframe.ColumnsContainer
import org.jetbrains.kotlinx.dataframe.api.*
import org.jetbrains.kotlinx.dataframe.columns.ColumnGroup
import org.jetbrains.kotlinx.kandy.dsl.internal.*
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*


class StatCount2DGroupBy<T, X, Y>(private val groupBy: GroupBy<T, StatCount2D<X, Y>>) :
    GroupBy<T, StatCount2D<X, Y>> by groupBy, ColumnsContainer<StatCount2D<X, Y>> by groupBy.groups.concat(),
    WithStatCount2DGrouped<T, X, Y> {

    override val Stat =
        WithStatCount2D.StatHolder<X, Y>(groupBy.groups.concat()["Stat"].asColumnGroup() as ColumnGroup<Count2DStatistics<X, Y>>)

    @Suppress("INVISIBLE_MEMBER")
    override val key: ColumnGroup<T> =
        groupBy.concatFixed().getColumns(*keys.columnNames().toTypedArray()).toColumnGroup(
            "key"
        ) as ColumnGroup<T>
}