package org.jetbrains.kotlinx.statistics.plotting.count2d.models

import org.jetbrains.kotlinx.dataframe.ColumnsContainer
import org.jetbrains.kotlinx.dataframe.DataColumn
import org.jetbrains.kotlinx.dataframe.DataFrame
import org.jetbrains.kotlinx.dataframe.api.asColumnGroup
import org.jetbrains.kotlinx.dataframe.columns.ColumnGroup

interface WithStatCount2D<X, Y> : ColumnsContainer<StatCount2D<X, Y>> {
    public val Stat: StatHolder<X, Y>

    public class StatHolder<X, Y>(private val cg: ColumnGroup<Count2DStatistics<X, Y>>): ColumnGroup<Count2DStatistics<X, Y>> by cg {
        val x: DataColumn<X> = cg["x"] as DataColumn<X>
        val y: DataColumn<Y> = cg["y"] as DataColumn<Y>
        val count: DataColumn<Int> = cg["count"] as DataColumn<Int>
        val countWeighted: DataColumn<Int> = cg["countWeighted"] as DataColumn<Int>
    }
}