package org.jetbrains.kotlinx.statistics.plotting.density.models

import org.jetbrains.kotlinx.dataframe.ColumnsContainer
import org.jetbrains.kotlinx.dataframe.api.*
import org.jetbrains.kotlinx.dataframe.columns.ColumnGroup
import org.jetbrains.kotlinx.kandy.dsl.internal.*
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*


class StatDensityGroupBy<T>(private val groupBy: GroupBy<T, StatDensity>) :
    GroupBy<T, StatDensity> by groupBy, ColumnsContainer<StatDensity> by groupBy.groups.concat(),
    WithStatDensityGrouped<T> {

    override val Stat =
        WithStatDensity.StatHolder(groupBy.groups.concat()["Stat"].asColumnGroup() as ColumnGroup<DensityStatistics>)

    @Suppress("INVISIBLE_MEMBER")
    override val key: ColumnGroup<T> =
        groupBy.concatFixed().getColumns(*keys.columnNames().toTypedArray()).toColumnGroup(
            "key"
        ) as ColumnGroup<T>

}
