package org.jetbrains.kotlinx.statistics.plotting.density.models

import org.jetbrains.kotlinx.dataframe.ColumnsContainer
import org.jetbrains.kotlinx.dataframe.DataColumn
import org.jetbrains.kotlinx.dataframe.columns.ColumnGroup

interface WithStatDensity: ColumnsContainer<StatDensity> {
    public val Stat: StatHolder

    public class StatHolder(private val cg: ColumnGroup<DensityStatistics>): ColumnGroup<DensityStatistics> by cg {
        val x: DataColumn<Double> = cg["x"] as DataColumn<Double>
        val density: DataColumn<Double> = cg["density"] as DataColumn<Double>
        val densityWeighted: DataColumn<Double> = cg["densityWeighted"] as DataColumn<Double>
        val scaled: DataColumn<Double> = cg["scaled"] as DataColumn<Double>
        val scaledWeighted: DataColumn<Double> = cg["scaledWeighted"] as DataColumn<Double>
        //val count: DataColumn<Double> = cg["count"] as DataColumn<Double>
    }
}
