package org.jetbrains.kotlinx.statistics.plotting.smooth

sealed interface SmoothMethod {
    data class Linear(val confidenceLevel: Double = 0.95) : SmoothMethod
    data class Polynomial(val degree: Int = 2, val confidenceLevel: Double = 0.95) : SmoothMethod
    data class LOESS(
        val span: Double = 0.5,
        val loessCriticalSize: Int = 1000,
        val samplingSeed: Long = 37L,
        val confidenceLevel: Double = 0.95
    ) : SmoothMethod
}