package org.jetbrains.kotlinx.statistics.plotting.smooth.models

import org.jetbrains.kotlinx.dataframe.ColumnsContainer
import org.jetbrains.kotlinx.dataframe.api.*
import org.jetbrains.kotlinx.dataframe.columns.ColumnGroup
import org.jetbrains.kotlinx.kandy.dsl.internal.*
import org.jetbrains.kotlinx.kandy.dsl.internal.dataframe.*


class StatSmoothGroupBy<T>(private val groupBy: GroupBy<T, StatSmooth>) :
    GroupBy<T, StatSmooth> by groupBy, ColumnsContainer<StatSmooth> by groupBy.groups.concat(),
    WithStatSmoothGrouped<T> {

    override val Stat =
        WithStatSmooth.StatHolder(groupBy.groups.concat()["Stat"].asColumnGroup() as ColumnGroup<SmoothStatistics>)

    @Suppress("INVISIBLE_MEMBER")
    override val key: ColumnGroup<T> =
        groupBy.concatFixed().getColumns(*keys.columnNames().toTypedArray()).toColumnGroup(
            "key"
        ) as ColumnGroup<T>

}
