package org.jetbrains.kotlinx.statistics.plotting.smooth.models

import org.jetbrains.kotlinx.dataframe.ColumnsContainer
import org.jetbrains.kotlinx.dataframe.DataColumn
import org.jetbrains.kotlinx.dataframe.DataFrame
import org.jetbrains.kotlinx.dataframe.columns.ColumnGroup

interface WithStatSmooth : ColumnsContainer<StatSmooth> {
    val Stat: StatHolder

    class StatHolder(private val cg: ColumnGroup<SmoothStatistics>) : ColumnGroup<SmoothStatistics> by cg {
        val x: DataColumn<Double> = cg["x"] as DataColumn<Double>
        val y: DataColumn<Double> = cg["y"] as DataColumn<Double>
        val yMin: DataColumn<Double> = cg["yMin"] as DataColumn<Double>
        val yMax: DataColumn<Double> = cg["yMax"] as DataColumn<Double>
        val se: DataColumn<Double> = cg["se"] as DataColumn<Double>
    }
}
