package org.jetbrains.kotlinx.statistics.selectors

import org.jetbrains.kotlinx.dataframe.ColumnsContainer
import org.jetbrains.kotlinx.dataframe.DataColumn
import org.jetbrains.kotlinx.dataframe.DataFrame

class StatCandlestickSelector<T, X>(df: DataFrame<T>) : ColumnsContainer<T> by df {
    @PublishedApi
    internal lateinit var x: DataColumn<X>
    fun x(column: DataColumn<X>) {
        x = column
    }

    @PublishedApi
    internal lateinit var open: DataColumn<Number>
    fun open(column: DataColumn<Number>) {
        open = column
    }

    @PublishedApi
    internal lateinit var high: DataColumn<Number>
    fun high(column: DataColumn<Number>) {
        high = column
    }

    @PublishedApi
    internal lateinit var low: DataColumn<Number>
    fun low(column: DataColumn<Number>) {
        low = column
    }

    @PublishedApi
    internal lateinit var close: DataColumn<Number>
    fun close(column: DataColumn<Number>) {
        close = column
    }
}

typealias StatCandlestickSelectorDSL<T, X> = StatCandlestickSelector<T, X>.() -> Unit