package org.jetbrains.kotlinx.statistics.selectors

import org.jetbrains.kotlinx.dataframe.ColumnsContainer
import org.jetbrains.kotlinx.dataframe.DataColumn
import org.jetbrains.kotlinx.dataframe.DataFrame

class StatXNumericSelector<T>(df: DataFrame<T>) : ColumnsContainer<T> by df {
    @PublishedApi
    internal lateinit var x: DataColumn<Number>
    fun x(column: DataColumn<Number>) {
        x = column
    }

    @PublishedApi
    internal var weights: DataColumn<Number>? = null
    fun weight(column: DataColumn<Number>) {
        weights = column
    }
}

typealias StatXNumericSelectorDSL<T> = StatXNumericSelector<T>.() -> Unit
