package org.jetbrains.kotlinx.statistics.selectors

import org.jetbrains.kotlinx.dataframe.ColumnsContainer
import org.jetbrains.kotlinx.dataframe.DataColumn
import org.jetbrains.kotlinx.dataframe.DataFrame

class StatXYNumSelector<T, X>(df: DataFrame<T>) : ColumnsContainer<T> by df {
    @PublishedApi
    internal lateinit var x: DataColumn<X>
    fun x(column: DataColumn<X>) {
        x = column
    }

    @PublishedApi
    internal lateinit var y: DataColumn<Number>
    fun y(column: DataColumn<Number>) {
        y = column
    }
}

typealias StatXYNumSelectorDSL<T, X> = StatXYNumSelector<T, X>.() -> Unit