package org.jetbrains.kotlinx.statistics.selectors

import org.jetbrains.kotlinx.dataframe.ColumnsContainer
import org.jetbrains.kotlinx.dataframe.DataColumn
import org.jetbrains.kotlinx.dataframe.DataFrame

class StatXYSelector<T, X, Y>(df: DataFrame<T>) : ColumnsContainer<T> by df {
    @PublishedApi
    internal lateinit var x: DataColumn<X>
    fun x(column: DataColumn<X>) {
        x = column
    }

    @PublishedApi
    internal lateinit var y: DataColumn<Y>
    fun y(column: DataColumn<Y>) {
        y = column
    }

    @PublishedApi
    internal var weights: DataColumn<Number>? = null
    fun weight(column: DataColumn<Number>) {
        weights = column
    }
}

typealias StatXYSelectorDSL<T, X, Y> = StatXYSelector<T, X, Y>.() -> Unit